import * as React from "react";
class Button extends React.PureComponent {
    constructor() {
        super(...arguments);
        this.state = {
            timeId: undefined,
        };
        this.keyUp = (e) => {
            const target = e.currentTarget;
            const { timeId } = this.state;
            if (timeId !== undefined) {
                window.clearTimeout(timeId);
            }
            target.classList.add("btn-clicked");
            const newTimeid = window.setTimeout(function () {
                target.classList.remove("btn-clicked");
            }, 400);
            this.setState({
                timeId: newTimeid,
            });
        };
    }
    componentWillUnmount() {
        const timeId = this.state.timeId;
        if (timeId) {
            clearTimeout(timeId);
        }
    }
    render() {
        const { children, handle, styleType, colorType, name, val, noAnimate, className, dataSet, disabled, } = this.props;
        return (React.createElement("button", { onClick: handle, "data-field": dataSet, value: val, name: name, disabled: disabled, className: `s-btn ${styleType} ${className} ${colorType}`, onMouseUp: !noAnimate ? this.keyUp : undefined }, children));
    }
}
Button.defaultProps = {
    styleType: "normal-btn",
    colorType: "primary",
    className: "",
};
export default Button;
