import * as React from "react";
const monFormatter = [
    "",
    "一",
    "二",
    "三",
    "四",
    "五",
    "六",
    "七",
    "八",
    "九",
    "十",
    "十一",
    "十二",
];
export default class CalendarMonthView extends React.PureComponent {
    getMonItemArr() {
        const { curTime: { year, month }, selTimeObj, clickSelHandle, showTimeObj, } = this.props;
        const selYear = selTimeObj.get("year");
        const selMonth = selTimeObj.get("month");
        const showYear = showTimeObj.get("year");
        let startMon = 0;
        const isMonToday = year === showYear;
        const issMonSel = selYear === showYear;
        return Array.from({ length: 4 }, (...args) => args[1] + 1).map(row => {
            const item = Array.from({ length: 3 }, (...args) => args[1] + 1).map(() => {
                const num = ++startMon;
                const monToday = (isMonToday && month === num && "calendar-today") || "";
                const monSel = (issMonSel && selMonth === num && "calendar-sel") || "";
                const className = "view-item " + monToday + " " + monSel;
                return (React.createElement("li", { "data-num": num, key: num, "data-sign": "month", className: className, onClick: !monSel ? clickSelHandle : undefined },
                    React.createElement("span", { className: "mon-span" }, monFormatter[num])));
            });
            return (React.createElement("ul", { className: "mon-group", key: row }, item));
        });
    }
    render() {
        return (React.createElement("div", { className: "m-monthView item-calendar-view" }, this.getMonItemArr()));
    }
}
