import * as React from "react";
import { ICommonInterface } from "./calendar";
declare type Props = {
    selTimeObj: ICommonInterface["showTimeObj"];
    showViewArr: ("fadeIn" | "fadeOut")[];
    viewIndex: 0 | 1;
    rotate: ICommonInterface["rotate"];
    curTime: ICommonInterface["curTime"];
    fixProps: ICommonInterface['fixProps'];
    changeBasicState: ICommonInterface["changeBasicState"];
};
declare type States = {
    showTimeObj: ICommonInterface["showTimeObj"];
    lastYear: number;
};
interface ICalendarView {
    changeSelTimeItme(viewIndex: number): void;
}
export default class CalendarView extends React.PureComponent<Props, States> implements ICalendarView {
    constructor(props: Props);
    getShowTimeObj(selTimeObj: ICommonInterface["showTimeObj"], curTime: ICommonInterface["curTime"]): IImmutalbeMap<{
        year: number;
        searson: number;
        month: number;
        day: number;
        hour: number;
        minute: number;
    }>;
    getLastYear(year: number): number;
    updatePanelYears(movePre: "next" | "back"): void;
    changeSelTimeItme: (viewIndex: number) => void;
    clickSelHandle: (e: React.MouseEvent<HTMLElement, MouseEvent>) => void;
    updatePanelDays(movePre: "next" | "back"): void;
    changeView: (e: React.MouseEvent<HTMLSpanElement, MouseEvent>) => void;
    changeRotate: (e: React.MouseEvent<HTMLElement, MouseEvent>) => void;
    controlBtnHandle: (e: React.MouseEvent<HTMLSpanElement, MouseEvent>) => void;
    getRotateCombo(arr: string[]): JSX.Element[];
    getSelTime(): JSX.Element | undefined;
    changeTime: (e: React.ChangeEvent<HTMLInputElement>) => void;
    render(): JSX.Element;
}
export {};
