import * as React from "react";
import ComboInp from "./ComboInp";
import * as Immutable from "immutable";
import { VelocityComponent } from "velocity-react";
const wrapComboHC = (Drop, comboType) => {
    var _a;
    return _a = class extends React.PureComponent {
            constructor(props) {
                super(props);
                this.wrapDomRef = React.createRef();
                this.bindSelectFn = (fn) => {
                    this.selectFn = fn;
                };
                this.dropToggle = () => {
                    this.setState(pre => ({
                        drop: !pre.drop,
                    }));
                };
                this.initSelect = (selected) => {
                    const { renderCallback } = this.props;
                    this.setState({
                        selected: selected
                    }, () => {
                        if (renderCallback) {
                            const { field, clickCallback } = this.props;
                            const { selected } = this.state;
                            clickCallback(selected.toJS(), field);
                        }
                    });
                };
                this.changeSelect = (selected, node) => {
                    const { clickCallback, field, multiply } = this.props;
                    this.setState((pre) => {
                        return {
                            selected: selected,
                            drop: !multiply ? false : pre.drop
                        };
                    }, () => {
                        const { selected } = this.state;
                        clickCallback(selected.toJS(), field, node);
                    });
                };
                this.documentClickFn = (e) => {
                    const target = e.target;
                    const wrap = this.wrapDomRef.current;
                    if (target !== wrap && wrap && !wrap.contains(target)) {
                        this.setState({
                            drop: false,
                        });
                    }
                };
                this.state = this.initState();
                this.initFieldObj(props);
                const { maxHeight } = props;
                this.dropStyle = { maxHeight: maxHeight, };
            }
            initFieldObj(props) {
                const { idField, textField, multiply, itemIcon, defaultVal, field, clickOrCheckForbid, } = props;
                const common = {
                    idField: idField,
                    textField: textField,
                    multiply,
                    itemIcon,
                    defaultVal: `${defaultVal}`,
                    clickOrCheckForbid,
                    field
                };
                if (comboType === "list") {
                    this.filedObj = Immutable.fromJS(common);
                }
                else {
                    const { childField, noSearch, } = props;
                    let treeField = Object.assign(common, { childField, noSearch });
                    this.filedObj = Immutable.fromJS(treeField);
                }
            }
            initState() {
                return {
                    drop: false,
                    selected: Immutable.List([]),
                };
            }
            componentDidMount() {
                document.addEventListener("click", this.documentClickFn);
            }
            componentWillUnmount() {
                document.removeEventListener("click", this.documentClickFn);
            }
            render() {
                const { formatterVal, noIcon, multiply, tit, width, data, dropWidth, noRequire, formatterDropItem, directionUp, ableClear, initComboVal } = this.props;
                const { selected, drop } = this.state;
                const palceholder = tit ? tit : multiply ? "多选" : "单选";
                return (React.createElement("div", { className: "g-combo", style: { width: width, }, ref: this.wrapDomRef },
                    React.createElement(ComboInp, { drop: drop, tit: palceholder, selected: selected, formatterVal: formatterVal, slideFn: this.dropToggle, noicon: noIcon, ableClear: ableClear, noRequire: noRequire, clearFn: this.selectFn }),
                    React.createElement(VelocityComponent, { duration: 300, animation: drop ? "slideDown" : "slideUp", interruptBehavior: "queue" },
                        React.createElement("div", { className: `m-drop ${directionUp ? "direction-up" : ""}`, style: dropWidth ? { width: dropWidth } : undefined },
                            React.createElement(Drop, { filedObj: this.filedObj, data: data, changeSelect: this.changeSelect, selected: selected, dropStyle: this.dropStyle, initSelect: this.initSelect, initComboVal: initComboVal, formatterDropItem: formatterDropItem, clickMethod: this.bindSelectFn })))));
            }
        },
        _a.defaultProps = {
            idField: "id",
            textField: "text",
            childField: "children",
            width: 240,
            maxHeight: 240,
            defaultVal: "",
            clickOrCheckForbid: function () {
                return false;
            }
        },
        _a;
};
export default wrapComboHC;
