import * as React from "react";
import wrapComboHQC from "./ComboBasic";
import * as Immutable from "immutable";
import { DropItem, activeStatus } from "./DropItem";
const formatterData = function (props, defaultVal) {
    const { filedObj, data, initSelect } = props;
    const id = filedObj.get("idField");
    const text = filedObj.get("textField");
    const multiply = filedObj.get("multiply");
    const defaultValArr = defaultVal.split(",");
    if (!multiply && defaultValArr.length > 1) {
        defaultValArr.length = 1;
    }
    const copyData = JSON.parse(JSON.stringify(data));
    let listSelect = [];
    let oldSelected = "";
    const _data = copyData.map((val, index) => {
        const isDefault = defaultValArr.includes(`${val[id]}`);
        val.active = isDefault
            ? activeStatus.select
            : activeStatus.noSelect;
        if (isDefault) {
            listSelect.push({ id: val[id], text: val[text] });
            if (!multiply) {
                oldSelected = `${index}`;
            }
        }
        return val;
    });
    initSelect(Immutable.List(listSelect));
    return {
        data: Immutable.fromJS(_data),
        singleClickPre: oldSelected
    };
};
const clickFn = function (index, props, state) {
    const { filedObj, selected, changeSelect } = props;
    const multipy = filedObj.get("multiply");
    const idField = filedObj.get("idField");
    const textField = filedObj.get("textField");
    const clickForbid = filedObj.get("clickOrCheckForbid");
    const comField = filedObj.get("field");
    let oldSelectedIndex = state.singleClickPre;
    const data = state.immutableData;
    let _data = data;
    let _select = selected;
    let newNode = _data.getIn([index]);
    if (!newNode) {
        return undefined;
    }
    if (clickForbid(newNode, comField)) {
        return undefined;
    }
    if (!multipy) {
        if (oldSelectedIndex === index) {
            return {
                immutableData: _data,
            };
        }
        if (oldSelectedIndex) {
            _data = _data.updateIn([oldSelectedIndex], (val) => {
                return val && val.set("active", activeStatus.noSelect);
            });
        }
        _select = _select.clear();
    }
    _data = _data.updateIn([index], (val) => {
        const active = val.get("active") === activeStatus.select
            ? activeStatus.noSelect
            : activeStatus.select;
        if (active === activeStatus.select) {
            _select = _select.push({
                id: val.get(idField),
                text: val.get(textField),
            });
        }
        else {
            if (multipy) {
                _select = _select.filter(_val => {
                    return _val.id !== val.get(idField);
                });
            }
        }
        const node = val.set("active", active);
        newNode = node;
        return node;
    });
    changeSelect(_select, newNode);
    if (!multipy) {
        oldSelectedIndex = index;
    }
    return {
        data: _data,
        singleClickPre: oldSelectedIndex
    };
};
class DropList extends React.PureComponent {
    constructor(props) {
        super(props);
        this.state = this.initState(this.props);
        this.clikItem = (id) => {
            if (!id) {
                this.clear();
                return;
            }
            const { immutableData } = this.state;
            const { filedObj } = this.props;
            const idField = filedObj.get("idField");
            const index = immutableData.findIndex(val => `${val.get(idField)}` === `${id}`);
            if (index !== -1) {
                this.clickFnForListMethod(`${index}`);
            }
        };
        this.clickFnForListMethod = (index) => {
            this.setState(pre => {
                const obj = clickFn(index, this.props, pre);
                if (obj) {
                    return {
                        immutableData: obj.data,
                        singleClickPre: obj.singleClickPre,
                    };
                }
                else {
                    return null;
                }
            });
        };
        this.state = this.initState(props);
        const { clickMethod } = props;
        clickMethod(this.clikItem);
    }
    static getDerivedStateFromProps(nextProps, preState) {
        const { preData, preInitComboVal } = preState;
        if (nextProps.data !== preData) {
            let initComboVal = nextProps.initComboVal;
            initComboVal = initComboVal ? initComboVal.id : "";
            const resObj = formatterData(nextProps, initComboVal);
            return {
                preData: nextProps.data,
                immutableData: resObj.data,
                singleClickPre: resObj.singleClickPre,
            };
        }
        else if (nextProps.initComboVal !== preInitComboVal) {
            const resObj = clickFn(nextProps.initComboVal.id, nextProps, preState);
            if (resObj) {
                return {
                    preInitComboVal: nextProps.initComboVal,
                    immutableData: resObj.data,
                    singleClickPre: resObj.singleClickPre
                };
            }
            else {
                return {
                    preInitComboVal: nextProps.initComboVal,
                };
            }
        }
        return null;
    }
    initState(props) {
        const { filedObj, data, initComboVal } = props;
        const defaultVal = filedObj.get("defaultVal");
        const obj = formatterData(props, defaultVal);
        return {
            immutableData: obj.data,
            preData: data,
            preInitComboVal: initComboVal,
            singleClickPre: obj.singleClickPre,
        };
    }
    clear() {
        const { changeSelect, selected, filedObj } = this.props;
        let _selected = selected;
        const idField = filedObj.get("idField");
        this.setState(pre => {
            let _data = pre.immutableData;
            _data = _data.withMutations(list => {
                return list.map(val => {
                    const has = _selected.find(select => `${select.id}` === `${val.get(idField)}`);
                    if (has) {
                        return val.set("active", activeStatus.noSelect);
                    }
                    else {
                        return val;
                    }
                });
            });
            return {
                immutableData: _data,
                singleClickPre: '',
            };
        });
        changeSelect(Immutable.List([]));
    }
    render() {
        const { immutableData } = this.state;
        const { filedObj, dropStyle, formatterDropItem } = this.props;
        const idField = filedObj.get("idField");
        const com = immutableData.map((node, index) => {
            return (React.createElement(DropItem, { key: node.get(idField), clickFn: this.clickFnForListMethod, node: node, formatterDropItem: formatterDropItem, fieldObj: filedObj, index: `${index}` }));
        });
        return (React.createElement("ul", { style: dropStyle, className: "drop-ul" }, com));
    }
}
export default wrapComboHQC(DropList, "list");
