import * as React from "react";
import * as Immutable from "immutable";
import { activeStatus } from "./DropItem";
import { drop, ISelected } from "./combo";
declare type props = drop<"tree">;
declare type states = {
    immutableData: Immutable.List<IImmutalbeMap<node>>;
    preData: any[];
    preInitComboVal: props['initComboVal'];
    oldSelectedIndex: string;
};
declare type node = {
    [key: string]: any;
    active: activeStatus;
    expand: boolean;
};
interface IDropTree {
    initState(props: props): states;
}
declare class DropTree extends React.PureComponent<props, states> implements IDropTree {
    static getDerivedStateFromProps(nextProps: props, preState: states): Partial<states> | null;
    constructor(props: props);
    initState(props: props): states;
    clear(): void;
    clickItem: (id?: string | undefined) => void;
    searchMap(data: any[], childField: string, key: string, textField: string): any[];
    searchFn: (key: string) => void;
    clickFnForTreeMethod: (path: string) => void;
    clickFn(index: string): void;
    checkMethod: (path: string) => void;
    checkFn(value: string): void;
    mapFn(list: IImmutalbeList<IImmutalbeMap<any>>, active: activeStatus, select: IImmutalbeList<ISelected>, filedObj: {
        idField: string;
        textField: string;
        childField: string;
    }): {
        arr: Immutable.List<IImmutalbeMap<any>>;
        selecte: IImmutalbeList<ISelected>;
    };
    checkForPar: (value: string) => void;
    checkForParFn(value: string): void;
    closeFn: () => void;
    toggleExpand: (index: string) => void;
    render(): JSX.Element;
}
export { DropTree };
declare const _default: {
    new (props: {
        data: any[];
        idField?: string | undefined;
        textField?: string | undefined;
        noIcon?: boolean | undefined;
        multiply?: boolean | undefined;
        tit?: string | undefined;
        field: string;
        itemIcon?: string | undefined;
        defaultVal?: string | undefined;
        width?: number | undefined;
        maxHeight?: number | undefined;
        dropWidth?: number | undefined;
        directionUp?: boolean | undefined;
        noRequire?: boolean | undefined;
        renderCallback?: boolean | undefined;
        ableClear?: boolean | undefined;
        initComboVal?: {
            id: string;
        } | undefined;
        clickOrCheckForbid?: ((node: IImmutalbeMap<any>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
        formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
        formatterDropItem?: ((node: IImmutalbeMap<any>) => React.ReactChild) | undefined;
        clickCallback(selected: ISelected[], field: string, node?: IImmutalbeMap<any> | undefined): void;
    } & {
        childField?: string | undefined;
        noSearch?: boolean | undefined;
        parAbleClick?: boolean | undefined;
    }): {
        filedObj: IImmutalbeMap<{
            idField: string;
            textField: string;
            multiply?: boolean | undefined;
            itemIcon?: string | undefined;
            defaultVal?: string | undefined;
            field: string;
            clickOrCheckForbid: (node: IImmutalbeMap<any>, field: string, selectedArr?: IImmutalbeList<ISelected> | undefined) => boolean;
        } & {
            childField?: string | undefined;
            noSearch?: boolean | undefined;
            parAbleClick?: boolean | undefined;
        }>;
        dropStyle: {
            maxHeight: number;
        };
        wrapDomRef: React.RefObject<HTMLDivElement>;
        selectFn: (path?: string | undefined) => void;
        bindSelectFn: (fn: any) => void;
        initFieldObj(props: {
            data: any[];
            idField?: string | undefined;
            textField?: string | undefined;
            noIcon?: boolean | undefined;
            multiply?: boolean | undefined;
            tit?: string | undefined;
            field: string;
            itemIcon?: string | undefined;
            defaultVal?: string | undefined;
            width?: number | undefined;
            maxHeight?: number | undefined;
            dropWidth?: number | undefined;
            directionUp?: boolean | undefined;
            noRequire?: boolean | undefined;
            renderCallback?: boolean | undefined;
            ableClear?: boolean | undefined;
            initComboVal?: {
                id: string;
            } | undefined;
            clickOrCheckForbid?: ((node: IImmutalbeMap<any>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
            formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
            formatterDropItem?: ((node: IImmutalbeMap<any>) => React.ReactChild) | undefined;
            clickCallback(selected: ISelected[], field: string, node?: IImmutalbeMap<any> | undefined): void;
        } & {
            childField?: string | undefined;
            noSearch?: boolean | undefined;
            parAbleClick?: boolean | undefined;
        }): void;
        dropToggle: () => void;
        initState(): {
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        };
        initSelect: (selected: IImmutalbeList<ISelected>) => void;
        changeSelect: (selected: IImmutalbeList<ISelected>, node?: IImmutalbeMap<any> | undefined) => void;
        documentClickFn: (e: MouseEvent) => void;
        componentDidMount(): void;
        componentWillUnmount(): void;
        render(): JSX.Element;
        context: any;
        setState<K extends "drop" | "selected">(state: {
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        } | ((prevState: Readonly<{
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        }>, props: Readonly<{
            data: any[];
            idField?: string | undefined;
            textField?: string | undefined;
            noIcon?: boolean | undefined;
            multiply?: boolean | undefined;
            tit?: string | undefined;
            field: string;
            itemIcon?: string | undefined;
            defaultVal?: string | undefined;
            width?: number | undefined;
            maxHeight?: number | undefined;
            dropWidth?: number | undefined;
            directionUp?: boolean | undefined;
            noRequire?: boolean | undefined;
            renderCallback?: boolean | undefined;
            ableClear?: boolean | undefined;
            initComboVal?: {
                id: string;
            } | undefined;
            clickOrCheckForbid?: ((node: IImmutalbeMap<any>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
            formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
            formatterDropItem?: ((node: IImmutalbeMap<any>) => React.ReactChild) | undefined;
            clickCallback(selected: ISelected[], field: string, node?: IImmutalbeMap<any> | undefined): void;
        } & {
            childField?: string | undefined;
            noSearch?: boolean | undefined;
            parAbleClick?: boolean | undefined;
        }>) => {
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        } | Pick<{
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        }, K> | null) | Pick<{
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        }, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        readonly props: Readonly<{
            data: any[];
            idField?: string | undefined;
            textField?: string | undefined;
            noIcon?: boolean | undefined;
            multiply?: boolean | undefined;
            tit?: string | undefined;
            field: string;
            itemIcon?: string | undefined;
            defaultVal?: string | undefined;
            width?: number | undefined;
            maxHeight?: number | undefined;
            dropWidth?: number | undefined;
            directionUp?: boolean | undefined;
            noRequire?: boolean | undefined;
            renderCallback?: boolean | undefined;
            ableClear?: boolean | undefined;
            initComboVal?: {
                id: string;
            } | undefined;
            clickOrCheckForbid?: ((node: IImmutalbeMap<any>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
            formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
            formatterDropItem?: ((node: IImmutalbeMap<any>) => React.ReactChild) | undefined;
            clickCallback(selected: ISelected[], field: string, node?: IImmutalbeMap<any> | undefined): void;
        } & {
            childField?: string | undefined;
            noSearch?: boolean | undefined;
            parAbleClick?: boolean | undefined;
        }> & Readonly<{
            children?: React.ReactNode;
        }>;
        state: Readonly<{
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        }>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        shouldComponentUpdate?(nextProps: Readonly<{
            data: any[];
            idField?: string | undefined;
            textField?: string | undefined;
            noIcon?: boolean | undefined;
            multiply?: boolean | undefined;
            tit?: string | undefined;
            field: string;
            itemIcon?: string | undefined;
            defaultVal?: string | undefined;
            width?: number | undefined;
            maxHeight?: number | undefined;
            dropWidth?: number | undefined;
            directionUp?: boolean | undefined;
            noRequire?: boolean | undefined;
            renderCallback?: boolean | undefined;
            ableClear?: boolean | undefined;
            initComboVal?: {
                id: string;
            } | undefined;
            clickOrCheckForbid?: ((node: IImmutalbeMap<any>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
            formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
            formatterDropItem?: ((node: IImmutalbeMap<any>) => React.ReactChild) | undefined;
            clickCallback(selected: ISelected[], field: string, node?: IImmutalbeMap<any> | undefined): void;
        } & {
            childField?: string | undefined;
            noSearch?: boolean | undefined;
            parAbleClick?: boolean | undefined;
        }>, nextState: Readonly<{
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        }>, nextContext: any): boolean;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<{
            data: any[];
            idField?: string | undefined;
            textField?: string | undefined;
            noIcon?: boolean | undefined;
            multiply?: boolean | undefined;
            tit?: string | undefined;
            field: string;
            itemIcon?: string | undefined;
            defaultVal?: string | undefined;
            width?: number | undefined;
            maxHeight?: number | undefined;
            dropWidth?: number | undefined;
            directionUp?: boolean | undefined;
            noRequire?: boolean | undefined;
            renderCallback?: boolean | undefined;
            ableClear?: boolean | undefined;
            initComboVal?: {
                id: string;
            } | undefined;
            clickOrCheckForbid?: ((node: IImmutalbeMap<any>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
            formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
            formatterDropItem?: ((node: IImmutalbeMap<any>) => React.ReactChild) | undefined;
            clickCallback(selected: ISelected[], field: string, node?: IImmutalbeMap<any> | undefined): void;
        } & {
            childField?: string | undefined;
            noSearch?: boolean | undefined;
            parAbleClick?: boolean | undefined;
        }>, prevState: Readonly<{
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        }>): any;
        componentDidUpdate?(prevProps: Readonly<{
            data: any[];
            idField?: string | undefined;
            textField?: string | undefined;
            noIcon?: boolean | undefined;
            multiply?: boolean | undefined;
            tit?: string | undefined;
            field: string;
            itemIcon?: string | undefined;
            defaultVal?: string | undefined;
            width?: number | undefined;
            maxHeight?: number | undefined;
            dropWidth?: number | undefined;
            directionUp?: boolean | undefined;
            noRequire?: boolean | undefined;
            renderCallback?: boolean | undefined;
            ableClear?: boolean | undefined;
            initComboVal?: {
                id: string;
            } | undefined;
            clickOrCheckForbid?: ((node: IImmutalbeMap<any>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
            formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
            formatterDropItem?: ((node: IImmutalbeMap<any>) => React.ReactChild) | undefined;
            clickCallback(selected: ISelected[], field: string, node?: IImmutalbeMap<any> | undefined): void;
        } & {
            childField?: string | undefined;
            noSearch?: boolean | undefined;
            parAbleClick?: boolean | undefined;
        }>, prevState: Readonly<{
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        }>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<{
            data: any[];
            idField?: string | undefined;
            textField?: string | undefined;
            noIcon?: boolean | undefined;
            multiply?: boolean | undefined;
            tit?: string | undefined;
            field: string;
            itemIcon?: string | undefined;
            defaultVal?: string | undefined;
            width?: number | undefined;
            maxHeight?: number | undefined;
            dropWidth?: number | undefined;
            directionUp?: boolean | undefined;
            noRequire?: boolean | undefined;
            renderCallback?: boolean | undefined;
            ableClear?: boolean | undefined;
            initComboVal?: {
                id: string;
            } | undefined;
            clickOrCheckForbid?: ((node: IImmutalbeMap<any>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
            formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
            formatterDropItem?: ((node: IImmutalbeMap<any>) => React.ReactChild) | undefined;
            clickCallback(selected: ISelected[], field: string, node?: IImmutalbeMap<any> | undefined): void;
        } & {
            childField?: string | undefined;
            noSearch?: boolean | undefined;
            parAbleClick?: boolean | undefined;
        }>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<{
            data: any[];
            idField?: string | undefined;
            textField?: string | undefined;
            noIcon?: boolean | undefined;
            multiply?: boolean | undefined;
            tit?: string | undefined;
            field: string;
            itemIcon?: string | undefined;
            defaultVal?: string | undefined;
            width?: number | undefined;
            maxHeight?: number | undefined;
            dropWidth?: number | undefined;
            directionUp?: boolean | undefined;
            noRequire?: boolean | undefined;
            renderCallback?: boolean | undefined;
            ableClear?: boolean | undefined;
            initComboVal?: {
                id: string;
            } | undefined;
            clickOrCheckForbid?: ((node: IImmutalbeMap<any>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
            formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
            formatterDropItem?: ((node: IImmutalbeMap<any>) => React.ReactChild) | undefined;
            clickCallback(selected: ISelected[], field: string, node?: IImmutalbeMap<any> | undefined): void;
        } & {
            childField?: string | undefined;
            noSearch?: boolean | undefined;
            parAbleClick?: boolean | undefined;
        }>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<{
            data: any[];
            idField?: string | undefined;
            textField?: string | undefined;
            noIcon?: boolean | undefined;
            multiply?: boolean | undefined;
            tit?: string | undefined;
            field: string;
            itemIcon?: string | undefined;
            defaultVal?: string | undefined;
            width?: number | undefined;
            maxHeight?: number | undefined;
            dropWidth?: number | undefined;
            directionUp?: boolean | undefined;
            noRequire?: boolean | undefined;
            renderCallback?: boolean | undefined;
            ableClear?: boolean | undefined;
            initComboVal?: {
                id: string;
            } | undefined;
            clickOrCheckForbid?: ((node: IImmutalbeMap<any>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
            formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
            formatterDropItem?: ((node: IImmutalbeMap<any>) => React.ReactChild) | undefined;
            clickCallback(selected: ISelected[], field: string, node?: IImmutalbeMap<any> | undefined): void;
        } & {
            childField?: string | undefined;
            noSearch?: boolean | undefined;
            parAbleClick?: boolean | undefined;
        }>, nextState: Readonly<{
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        }>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<{
            data: any[];
            idField?: string | undefined;
            textField?: string | undefined;
            noIcon?: boolean | undefined;
            multiply?: boolean | undefined;
            tit?: string | undefined;
            field: string;
            itemIcon?: string | undefined;
            defaultVal?: string | undefined;
            width?: number | undefined;
            maxHeight?: number | undefined;
            dropWidth?: number | undefined;
            directionUp?: boolean | undefined;
            noRequire?: boolean | undefined;
            renderCallback?: boolean | undefined;
            ableClear?: boolean | undefined;
            initComboVal?: {
                id: string;
            } | undefined;
            clickOrCheckForbid?: ((node: IImmutalbeMap<any>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
            formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
            formatterDropItem?: ((node: IImmutalbeMap<any>) => React.ReactChild) | undefined;
            clickCallback(selected: ISelected[], field: string, node?: IImmutalbeMap<any> | undefined): void;
        } & {
            childField?: string | undefined;
            noSearch?: boolean | undefined;
            parAbleClick?: boolean | undefined;
        }>, nextState: Readonly<{
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        }>, nextContext: any): void;
    };
    defaultProps: {
        idField: string;
        textField: string;
        childField: string;
        width: number;
        maxHeight: number;
        defaultVal: string;
        clickOrCheckForbid: () => boolean;
    };
    contextType?: React.Context<any> | undefined;
};
export default _default;
