import * as ReactDom from "react-dom";
import * as React from "react";
class Loading extends React.PureComponent {
    constructor() {
        super(...arguments);
        this.state = {
            show: true,
            hasShade: false
        };
        this.toggle = (show, hasShade) => {
            this.setState({
                show: show,
                hasShade: !!hasShade
            });
        };
    }
    render() {
        const { show, hasShade } = this.state;
        const shadeName = hasShade ? "g-shade" : "";
        return (React.createElement("div", { className: `g-loading ${shadeName} ${!show ? "hide-loading" : ""}` },
            React.createElement("div", { className: "m-loading" },
                React.createElement("b", { className: "loading-text" }, "loading..."))));
    }
}
let loadingRef = null;
const createLoad = function (callback) {
    const wrap = document.getElementById("wrap-loading");
    ReactDom.render(React.createElement(Loading, { ref: ref => (loadingRef = ref) }), wrap, function () {
        if (callback) {
            callback();
        }
    });
};
const loadfn = {
    open: function (hasShade) {
        if (!loadingRef) {
            createLoad(function () {
                loadingRef.toggle(true, hasShade);
            });
        }
        else {
            loadingRef.toggle(true, hasShade);
        }
    },
    close: function () {
        if (loadingRef) {
            loadingRef.toggle(false);
        }
    },
};
export { createLoad };
export default loadfn;
