import * as React from "react";
import * as Immutable from "immutable";
import { IMenuData, fieldObj } from "./menu";
declare type props = {
    data: IMenuData[];
    width?: number;
    expand: boolean;
    textField?: string;
    idField?: string;
    urlField?: string;
    iconField?: string;
    defaultMenuId?: string;
    init?: {
        id: string;
    };
    clickBack?: (node: {
        [key: string]: any;
    }) => void;
};
declare type states = {
    selected: string;
    immutableData: Immutable.List<IImmutalbeMap<{
        children: Immutable.List<IImmutalbeMap<IMenuData>>;
        [key: string]: any;
        selected: boolean;
    }>>;
    fieldObj: fieldObj;
    preData: any[];
    preInit: {
        id: string;
    } | undefined;
};
interface INavMenu {
    initState(props: props): states;
    getParMenu(): Immutable.List<JSX.Element>;
    changeImmutableData(callback: (data: states["immutableData"], selected: string) => {
        data: states["immutableData"];
        selected: string;
    }): void;
}
declare class NavMenu extends React.PureComponent<props, states> implements INavMenu {
    static defaultProps: {
        textField: string;
        idField: string;
        iconField: string;
        urlField: string;
        width: number;
    };
    static getDerivedStateFromProps(nextProps: props, preState: states): Partial<states> | null;
    constructor(prop: props);
    initState(props: props): {
        selected: string;
        immutableData: any;
        fieldObj: IImmutalbeMap<{
            id: string;
            text: string;
            url: string;
            icon: string;
        }>;
        preData: IMenuData[];
        preInit: {
            id: string;
        } | undefined;
    };
    getParMenu(): Immutable.List<JSX.Element>;
    changeImmutableData: (callback: (data: Immutable.List<IImmutalbeMap<{
        [key: string]: any;
        children: Immutable.List<IImmutalbeMap<IMenuData>>;
        selected: boolean;
    }>>, selected: string) => {
        data: Immutable.List<IImmutalbeMap<{
            [key: string]: any;
            children: Immutable.List<IImmutalbeMap<IMenuData>>;
            selected: boolean;
        }>>;
        selected: string;
    }) => void;
    render(): JSX.Element;
}
export default NavMenu;
