import * as React from "react";
import { GroupCols } from './GroupCols';
import { activeStatus } from './formatterTreeData';
import { ICommon } from "./mytreeTable";
declare type childType = React.ComponentElement<ICommon['groupCol'], any>;
declare type Props = {
    data: any[];
    children: childType[] | childType;
    noOrder?: boolean;
    height?: number;
    multiply?: boolean;
    itemIcon?: string;
    childField?: string;
    idField: string;
    defaultSel?: string;
    tabField?: string;
    emptyTxt?: string;
    getCheckFn?: (fn: any) => void;
    initSelectVal?: {
        id: string;
    };
    clickOrCheckForbid?: (node: IImmutalbeMap<any>, field?: string) => boolean;
    bindGetSelectedFn?: (getSelected: () => IImmutalbeList<IImmutalbeMap<any>>) => void;
};
declare type States = {
    immutabData: IImmutalbeList<IImmutalbeMap<ICommon['node']>>;
    selectArr: IImmutalbeList<string>;
    preData: any[];
    preInitSelect?: {
        id: string;
    };
};
declare type config = ICommon['config'];
interface ITreeTable {
    fieldArr: config[];
    fixObj: ICommon['fixObj'];
}
declare class TreeTable extends React.PureComponent<Props, States> implements ITreeTable {
    static defaultProps: {
        idField: string;
        childField: string;
        defaultSel: string;
    };
    static getDerivedStateFromProps(nextProps: Props, preState: States): Partial<States> | null;
    fixObj: ITreeTable['fixObj'];
    tabMainTabBodyDomArr: HTMLDivElement[];
    fieldArr: ITreeTable['fieldArr'];
    constructor(props: Props);
    getFieldArr(arr: Props['children']): {
        child: {
            width: number;
            field: string;
            formatter: ((node: IImmutalbeMap<any>, index: number, tabField?: string | undefined) => React.ReactChild) | undefined;
            text: string;
            align: "left" | "right" | "center" | undefined;
        }[];
        width: number;
        forzen: boolean | undefined;
    }[];
    expand(path: string): void;
    checkChild(path: string): void;
    mapFn(list: IImmutalbeList<IImmutalbeMap<any>>, active: activeStatus, select: IImmutalbeList<string>): {
        arr: import("immutable").List<IImmutalbeMap<any>>;
        selecte: IImmutalbeList<string>;
    };
    checkPar(path: string): void;
    changeState: ICommon['changeState'];
    initFixObj(): {
        tabField: string | undefined;
        emptyTxt: string | undefined;
        itemIcon: string | undefined;
        noOrder: boolean | undefined;
        idField: string;
        multiply: boolean | undefined;
        defaultSel: string | undefined;
        childField: string;
    };
    changeScrollTop: (top: number, index: number) => void;
    viewMap(): JSX.Element[];
    setTabBodyDom: (dom: HTMLDivElement, index: number) => void;
    setTabViewBottomFixHeight(): void;
    componentDidMount(): void;
    setSameH(): void;
    setDom(): void;
    mapDom(domArr: HTMLDivElement[]): void;
    whileDomH(): void;
    render(): JSX.Element;
}
export { TreeTable, GroupCols };
