class Event {
    constructor() {
        this.eventObj = {};
    }
    on(eventType, fn) {
        let eventList = this.eventObj[eventType];
        if (!eventList) {
            eventList = [];
            this.eventObj[eventType] = eventList;
        }
        eventList.push(fn);
    }
    emit(eventType, ...other) {
        let eventList = this.eventObj[eventType];
        if (!eventList || !eventList.length) {
            return;
        }
        eventList.forEach(fn => {
            fn(...other);
        });
    }
    remove(eventType) {
        this.eventObj[eventType] = null;
        delete this.eventObj[eventType];
    }
}
const event = new Event();
export { event };
